;;;; cl-scopes/storage/folder - persistent folders, stored in a SQL database.

(defpackage :scopes/storage/folder
  (:use :common-lisp)
  (:local-nicknames (:shape :scopes/shape)
                    (:tracking :scopes/storage/tracking)
                    (:util :scopes/util))
  (:export #:folder #:root #:create
           #:make-container))

(in-package :scopes/storage/folder)

(defclass folder (tracking:track)
  ((shape:head-fields :initform '(:parentid :name :ref))
   (tracking:key-fields :initform '(:parentid :name))))

(defun indexes (cont)
  '((parentid name ref) (ref)))

(defun make-container (storage)
  (make-instance 'tracking:container 
                 :item-class 'folder
                 :short-name :fldr
                 :table-name :folders
                 :index-factory #'indexes
                 :force-insert-when nil
                 :storage storage))

(defun root (cont)
  (tracking:save (tracking:make-item cont nil :root)))

(defun create (name parent)
  (let ((cont (tracking:container parent))
        (pid (write-to-string (tracking:trackid parent))))
    (tracking:save (tracking:make-item cont pid name))))
